config/routes.rb
Rails.application.routes.draw do
  resources :collaborations
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  # resources :assignment_submissions
  resources :group_members ,only: [:create,:destroy]
  resources :groups do
    resources :assignments
  end

  scope '/groups' do
    get '/:id/assignments/WYSIWYG/index.css', to: redirect('/index.css')
    get '/:id/assignments/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')
    get '/:id/assignments/:id/WYSIWYG/index.css', to: redirect('/index.css')      # in case of editing
    get '/:id/assignments/:id/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')   # in case of editing
    get '/:group_id/assignments/:id/reopen', to: 'assignments#reopen', as: 'reopen_group_assignment'
    get '/:group_id/assignments/:id/start', to: 'assignments#start', as: 'assignment_start'
  end
  resources :stars , only: [:create, :destroy]


  devise_for :users, controllers: {registrations: 'users/registrations', :omniauth_callbacks => "users/omniauth_callbacks"}


  #Logix web pages resources
  root 'logix#index'
  get  '/gettingStarted', to:'logix#gettingStarted'
  get  '/examples', to:'logix#examples'
  get  '/features', to:'logix#features'
  get  '/about', to:'logix#about'
  get  '/privacy', to:'logix#privacy'
  get  '/tos', to:'logix#tos'
  get  '/search', to:'logix#search'
  get  '/teachers', to:'logix#teachers'
  get  '/contribute', to:'logix#contribute'

  #users
  scope '/users' do
    get '/', to: 'welcome#all_user_index', as: 'all_users'
    get '/:id/profile', to: 'users/logix#profile', as: 'profile'
    get '/:id/profile/edit', to: 'users/logix#edit', as: 'profile_edit'
    patch '/:id/update', to: 'users/logix#update', as: 'profile_update'
    get '/:id/groups', to: 'users/logix#groups', as: 'user_groups'
    get '/:id/', to: 'users/logix#index', as: 'user_projects'
    get '/:id/favourites', to: 'users/logix#favourites', as: 'user_favourites'
    get '/:id/projects/:id/WYSIWYG/index.css', to: redirect('/index.css')
    get '/:id/projects/:id/WYSIWYG/bootstrap-wysiwyg.js', to: redirect('/bootstrap-wysiwyg.js')
  end


  #projects
  get 'projects/create_fork/:id', to: 'projects#create_fork',as: 'create_fork_project'
  get 'projects/change_stars/:id', to: 'projects#change_stars', as: 'change_stars'

  mount Commontator::Engine => '/commontator'

  #simulator
  scope '/simulator' do
    get '/:id', to: 'simulator#show', as: 'simulator'
    get '/edit/:id', to: 'simulator#edit', as: 'simulator_edit'
    post '/get_data', to: 'simulator#get_data'
    post '/update_data', to: 'simulator#update'
    post '/update_image', to: 'simulator#update_image'
    post '/create_data', to: 'simulator#create'
    get '/', to: 'simulator#new', as: 'simulator_new'
    get '/embed/:id', to: 'simulator#embed', as: 'simulator_embed'
  end
  # get 'simulator/embed_cross/:id', to: 'simulator#embed_cross', as: 'simulator_embed_cross'


  resources :users do
    resources :projects, only: [:show, :edit, :update, :new, :create, :destroy]
  end




  # get 'comments/create_reply/:id', to: 'comments#create_reply', as: 'reply_comment'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  has_many :projects,  :foreign_key => 'author_id' , dependent: :destroy
  has_many :stars
  has_many :rated_projects,   through: :stars , dependent: :destroy , source: 'project'
  has_many :groups_mentored, class_name: 'Group',  :foreign_key => 'mentor_id' , dependent: :destroy
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable, :omniauthable, :omniauth_providers => [:google_oauth2,:facebook]

  # has_many :assignments, foreign_key: 'mentor_id', dependent: :destroy
  has_many :group_members, dependent: :destroy
  has_many :groups, through: :group_members
  acts_as_commontator

  has_many :collaborations, dependent: :destroy
  has_many :collaborated_projects, source: 'project', through: :collaborations

  after_commit :send_mail ,  on: :create
  after_commit :check_group_invites, on: :create

  has_attached_file :profile_picture, styles: { medium: "205X240#", thumb: "100x100>" }, default_url: ":style/Default.jpg"
  validates_attachment_content_type :profile_picture, content_type: /\Aimage\/.*\z/

  def send_mail
    UserMailer.welcome_email(self).deliver_later
  end

  def check_group_invites
    PendingInvitation.where(email:self.email).each do |invitation|
      GroupMember.where(group_id:invitation.group.id,user_id:self.id).first_or_create
      invitation.destroy
    end
  end

  def self.from_omniauth(access_token)
    data = access_token.info
    user = User.where(email: data['email']).first
    # Uncomment the section below if you want users to be created if they don't exist
    unless user
        user = User.create(name: data['name'],
           email: data['email'],
           password: Devise.friendly_token[0,20],
           provider: access_token.provider,
           uid: access_token.uid
        )
    end
    user
  end
end

app/controllers/logix_controller.rb
class LogixController < ApplicationController
  # before_action :authenticate_user!

  def index
      @projects = Project.select("id,author_id,image_preview,name").where(project_access_type:"Public",forked_project_id:nil).paginate(:page => params[:page]).order("id desc").limit(Project.per_page)

      respond_to do |format|
        format.html # index.html.erb
        format.json { render json: @projects }
        format.js
      end

  end

  def gettingStarted
  end

  def examples
  end

  def features
  end

  def about
  end

  def all_user_index
  end

  def privacy
  end

  def tos
  end

  def teachers
  end

  def contribute
  end

end

app/controllers/users/confirmations_controller.rb
class Users::ConfirmationsController < Devise::ConfirmationsController
  # GET /resource/confirmation/new
  # def new
  #   super
  # end

  # POST /resource/confirmation
  # def create
  #   super
  # end

  # GET /resource/confirmation?confirmation_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after resending confirmation instructions.
  # def after_resending_confirmation_instructions_path_for(resource_name)
  #   super(resource_name)
  # end

  # The path used after confirmation.
  # def after_confirmation_path_for(resource_name, resource)
  #   super(resource_name, resource)
  # end
end

app/controllers/users/logix_controller.rb
class Users::LogixController < ApplicationController
  before_action :authenticate_user! ,only: [:edit, :update, :groups]
  def index
    @user = User.find(params[:id])
    @edit_access = (user_signed_in? and current_user.id == @user.id)
  end
  def favourites
    @user = User.find(params[:id])
    @projects = @user.rated_projects
  end
  def profile
    @profile = User.find(params[:id])
  end
  def edit
    @profile = current_user
  end
  def update
    @profile = current_user
    @profile.name = params["profile"]["name"]
    if params["profile"]["profile_picture"]!=nil
      @profile.profile_picture = params["profile"]["profile_picture"]
    end
    @profile.save
    redirect_to profile_path(current_user)
  end
  def groups
  end
end

app/controllers/users/omniauth_callbacks_controller.rb
class Users::OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # You should configure your model like this:
  # devise :omniauthable, omniauth_providers: [:twitter]

  # You should also create an action method in this controller like this:
  # def twitter
  # end

  # More info at:
  # https://github.com/plataformatec/devise#omniauth

  # GET|POST /resource/auth/twitter
  # def passthru
  #   super
  # end

  # GET|POST /users/auth/twitter/callback
  # def failure
  #   super
  # end

  # protected

  # The path used when OmniAuth fails
  # def after_omniauth_failure_path_for(scope)
  #   super(scope)
  # end

  def facebook
    generic_callback( 'facebook' )
  end

  def google_oauth2
    generic_callback( 'google' )
  end

  def microsoft_office365
      generic_callback( 'microsoft_office365' )
  end

  def generic_callback( provider )
    @user = User.from_omniauth(request.env["omniauth.auth"])
    if @user.persisted?
      sign_in_and_redirect @user, event: :authentication
      set_flash_message(:notice, :success, kind: provider.capitalize) if is_navigational_format?
    else
      session["devise.#{provider}_data"] = env["omniauth.auth"]
      redirect_to new_user_registration_url
    end
  end
end

app/controllers/users/passwords_controller.rb
class Users::PasswordsController < Devise::PasswordsController
  # GET /resource/password/new
  # def new
  #   super
  # end

  # POST /resource/password
  # def create
  #   super
  # end

  # GET /resource/password/edit?reset_password_token=abcdef
  # def edit
  #   super
  # end

  # PUT /resource/password
  # def update
  #   super
  # end

  # protected

  # def after_resetting_password_path_for(resource)
  #   super(resource)
  # end

  # The path used after sending reset password instructions
  # def after_sending_reset_password_instructions_path_for(resource_name)
  #   super(resource_name)
  # end
end

app/controllers/users/registrations_controller.rb
class Users::RegistrationsController < Devise::RegistrationsController
  before_action :configure_sign_up_params, only: [:create]
  # before_action :configure_account_update_params, only: [:update]

  # GET /resource/sign_up
  # def new
  #   super
  # end

  # POST /resource
  # def create
  #   super
  # end

  # GET /resource/edit
  # def edit
  #   super
  # end

  # PUT /resource
  # def update
  #   super
  # end

  # DELETE /resource
  # def destroy
  #   super
  # end

  # GET /resource/cancel
  # Forces the session data which is usually expired after sign
  # in to be expired now. This is useful if the user wants to
  # cancel oauth signing in/up in the middle of the process,
  # removing all OAuth session data.
  # def cancel
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  def configure_sign_up_params
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name,:age])
  end

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_account_update_params
  #   devise_parameter_sanitizer.permit(:account_update, keys: [:attribute])
  # end

  # The path used after sign up.
  # def after_sign_up_path_for(resource)
  #   super(resource)
  # end

  # The path used after sign up for inactive accounts.
  # def after_inactive_sign_up_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users/sessions_controller.rb
class Users::SessionsController < Devise::SessionsController
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /resource/sign_in
  # def create
  #   super
  # end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/controllers/users/unlocks_controller.rb
class Users::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/views/users/logix/_dashboard.html.erb
<% projects.each do |project| %>

    <%if project.check_direct_view_access(current_user) %>
        <div class="col-sm-4">
          <div class="card text-center " style="margin-top: 2rem">
            <div class="card-header card-title">
              <%= project.name %>
              <%if !project.assignment_id.nil?%>
                  <span class="badge badge-primary">Assignment</span>
              <%end%>

              <span class="badge badge-secondary"><%= project.project_access_type%></span>

            </div>
            <img class="card-img-top " src="<%= project.image_preview.url %>" alt="<%= project.name%>" >
            <div class="card-footer ">
              <style>
                .btn {
                  margin-top: 5px;
                }
              </style>
              <a href=  "<%= user_project_path(@user,project) %>" class="btn btn-primary" target="_blank"> More </a>
              <a href="#" id="<%=project.id%>" class="previewButton btn btn-primary" data-toggle="modal" data-target="#myModal"> View </a>
              <% if @edit_access %>
                  <a href=  "<%= simulator_edit_path(project) %>" class="btn btn-primary" target="_blank"> Launch </a>
              <% else %>
                  <a href=  "<%= create_fork_project_path(project) %>" class="btn btn-primary" target="_blank"> Fork! </a>
              <% end %>
            </div>
          </div>
        </div>
    <%end%>

<% end %>

app/views/users/logix/edit.html.erb
<div class="container">
  <div class="row feature">

    <div class="container">

      <h2>Profile</h2>

      <!--<p> <strong>Name: </strong><%=@profile.name%></p>-->
      <!--<p> <strong>Email: </strong><%=@profile.email%></p>-->
      <!--<p> <strong>Member since: </strong><%=((Time.now.to_i - @profile.created_at.to_i)/1.day)%> days</p>-->
      <!--<p> <strong>Educational Institution: </strong> IIIT-Bangalore </p>-->
      <!--<p> <strong>Country: </strong> India </p>-->


      <%= form_for @profile, html: { multipart: true},  url: {action: "update"}  do |f| %>
          <div class="form-group">
            <label for="name">Name:</label>
            <input type="text" class="form-control" id="name" name="profile[name]" value = "<%= @profile.name%>">
          </div>
          <div class="form-group">
            <label for="profile_picture">Profile Picture:</label>
            <p> <%= image_tag @profile.profile_picture.url(:thumb)%></p>
            <input type="file" class="form-control" id="profile_picture" name="profile[profile_picture]" value = "<%= @profile.profile_picture%>">
          <!--<div class="form-group">-->
            <!--<label for="educational_institution">Educational Institution:</label>-->
            <!--<input type="text" class="form-control" id="educational_institution" placeholder="e.g. IIIT-Bangalore" name="profile[educational_institution]">-->
          <!--</div>-->
          <!--<div class="form-group">-->
            <!--<label for="country">Country:</label>-->
            <!--<input type="text" class="form-control" id="country" placeholder="Enter country" name="profile[country]">-->
          <!--</div>-->
          <button type="submit" class="btn btn-secondary">Save</button>
      <% end %>
    </div>


  </div>
  <br />

  <br />



</div>

app/views/users/logix/favourites.html.erb
<% content_for :title, @user.name + " - Favourite Circuits" %>
<% content_for :author_name, @user.name %>

<div class="container">
  <!--<%= link_to 'Back', all_users_path %>-->
  <div class ="row">
    <h2 class="card-title">Favourite Projects</h2>
  </div>

  <div class="row ">


    <% @projects.each do |project| %>

        <%if project.check_direct_view_access(current_user) %>
            <div class="col-sm-4">
              <div class="card text-center " style="margin-top: 2rem">
                <div class="card-header card-title">
                  <%= project.name %>
                  <%if !project.assignment_id.nil?%>
                      <span class="badge badge-primary">Assignment</span>
                  <%end%>

                  <span class="badge badge-secondary"><%= project.project_access_type%></span>

                </div>
                <img class="card-img-top " src="<%= project.image_preview.url %>" alt="<%= project.name%>" >
                <div class="card-footer ">
                  <style>
                    .btn {
                      margin-top: 5px;
                    }
                  </style>
                  <a href=  "<%= user_project_path(@user,project) %>" class="btn btn-primary" target="_blank"> More </a>
                  <a href="#" id="<%=project.id%>" class="previewButton btn btn-primary" data-toggle="modal" data-target="#myModal"> View </a>
                  <% if @edit_access %>
                      <a href=  "<%= simulator_edit_path(project) %>" class="btn btn-primary" target="_blank"> Launch </a>
                  <% else %>
                      <a href=  "<%= create_fork_project_path(project) %>" class="btn btn-primary" target="_blank"> Fork! </a>
                  <% end %>
                </div>
              </div>
            </div>
        <%end%>

    <% end %>

  </div>

</div>

<br>



<div id="myModal" class="modal fade" role="dialog">
  <div class="modal-dialog modal-lg">

    <!-- Modal content-->
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Project Preview</h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>

      </div>
      <div class="modal-body">
        <div class="embed-responsive embed-responsive-4by3 feature">
          <iframe src="" id="projectPreview" scrolling="no" webkitAllowFullScreen mozAllowFullScreen allowFullScreen> </iframe>
        </div>
      </div>
      <!--<div class="modal-footer">-->
      <!--<button type="button" class="btn btn-secondary" data-dismiss="modal">close</button>-->
      <!--</div>-->
    </div>

  </div>
</div>

<script>
    $( function() {
        $('.previewButton').on('click', function (e) {
            e.preventDefault()
            $("#projectPreview").attr("src","/simulator/" + e.currentTarget.id );
            $("#myModal").tab('show')
        })
    } );
</script>

app/views/users/logix/groups.html.erb
<div class="container">
  <div class="row feature">

    <div class="col">
      <%= link_to 'New Group +', new_group_path, class: "btn btn-info" %>
      <% if notice %>
          <p id="notice" class="alert alert-danger"><%= notice %></p>
        <% end %>

      <% if current_user.groups.count!=0 %>
          <h1>Groups you belong to: </h1>
          <table class="table">
            <thead>
            <tr>
              <th>Name</th>
              <th>Mentor</th>
              <th colspan="3"></th>
            </tr>
            </thead>

            <tbody>
            <% current_user.groups.each do |group| %>
                <tr>
                  <td><%= group.name %></td>
                  <td><%= group.mentor.name %></td>
                  <td><%= link_to 'Show', group %></td>
                  <%if group.mentor.id == current_user.id %>
                      <td><%= link_to 'Edit', edit_group_path(group) %></td>
                      <td><%= link_to 'Destroy', group, method: :delete, data: { confirm: 'Are you sure?' } %></td>
                  <%end%>

                </tr>
            <% end %>
            </tbody>
          </table>

          <br>
      <% end %>

      <% if current_user.groups_mentored.count!=0 %>
          <h1>Groups you mentor: </h1>
          <table class="table">
            <thead>
            <tr>
              <th>Name</th>
              <th>Member Count</th>
              <th colspan="3">Actions</th>
            </tr>
            </thead>

            <tbody>
            <% current_user.groups_mentored.each do |group| %>
                <tr>
                  <td><%= group.name %></td>
                  <td><%= group.users.count %></td>
                  <td><%= link_to 'Show', group %></td>
                  <td><%= link_to 'Edit', edit_group_path(group) %></td>
                  <td><%= link_to 'Destroy', group, method: :delete, data: { confirm: 'Are you sure?' } %></td>
                </tr>
            <% end %>
            </tbody>
          </table>

          <br>
      <% end %>



    </div>


  </div>
  <br />

  <br />



</div>

app/views/users/logix/index.html.erb
<% content_for :title, @user.name + " - Circuits" %>
<% content_for :author_name, @user.name %>

<div class="container">
  <!--<%= link_to 'Back', all_users_path %>-->

  <% if notice %>
      <div class="row">
          <div class="alert alert-success alert-dismissible container-fluid text-center">
              <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
              <%= notice %>
          </div>
      </div>
  <% end %>

  <div class ="row">
    <h2 class="card-title"><%= @user.name%> - Projects | <a href=  "<%= profile_path(@user)%>"  target="_blank"> View Profile </a> | <a href=  "<%= user_favourites_path(@user)%>"  target="_blank"> View Favourites </a> </h2>
  </div>

  <div class="row">
    <%= render partial: "dashboard" , locals: {projects: @user.projects} %>
  </div>

  <% collaborated_projects = @user.collaborated_projects %>

  <% if collaborated_projects.count >0 %>
      <br>
    <div class ="row">
      <h2 class="card-title">Collaborated Projects </h2>
    </div>

    <div class="row">
      <%= render partial: "dashboard" , locals: {projects: collaborated_projects} %>
    </div>
  <%end %>

</div>

<br>



<div id="myModal" class="modal fade" role="dialog">
  <div class="modal-dialog modal-lg">

    <!-- Modal content-->
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Project Preview</h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>

      </div>
      <div class="modal-body">
        <div class="embed-responsive embed-responsive-4by3 feature">
          <iframe src="" id="projectPreview" scrolling="no" webkitAllowFullScreen mozAllowFullScreen allowFullScreen> </iframe>
        </div>
      </div>
      <!--<div class="modal-footer">-->
      <!--<button type="button" class="btn btn-secondary" data-dismiss="modal">close</button>-->
      <!--</div>-->
    </div>

  </div>
</div>

<script>
    $( function() {
        $('.previewButton').on('click', function (e) {
            e.preventDefault()
            $("#projectPreview").attr("src","/simulator/" + e.currentTarget.id );
            $("#myModal").tab('show')
        })
    } );
</script>

app/views/users/logix/profile.html.erb
    <div class="container">
        <div class="row feature">

            <div class="container">
               <h2>Profile</h2>
                <div class="row">
                   <div class="col-lg-8">
                    <p> <strong>Name: </strong><%=@profile.name%></p>
                    <p> <strong>Member since: </strong><%=((Time.now.to_i - @profile.created_at.to_i)/1.day)%> days</p>
                    <!--<p> <strong>Educational Institution: </strong> IIIT-Bangalore </p>-->
                    <!--<p> <strong>Country: </strong> India </p>-->
                    <% if user_signed_in? and current_user.id==@profile.id%>
                        <p><a class="btn btn-secondary" href = <%= profile_edit_path(current_user) %> role="button">Edit </a></p>
                    <% end %>
                  </div>
                  <div class="col-lg-4">
                      <%= image_tag @profile.profile_picture.url(:medium) , :style => "border: 2px solid black"%>
                  </div>
                </div>
            </div>


        </div>
        <br />

        <br />



    </div>